#include <bits/stdc++.h>
using namespace std;
const int N=1e6+5;
long long n,m,cnt,ans,a[N][N];
long long rec(long long x, long long y){
	if(y>x){
		swap(x,y);
	}
	if(a[x][y]!=0){
		return a[x][y];
	}
	else{
		if(x%2==0){
			return rec(x/2,y)+rec(x/2,y)+x*y;
		}
		else{
			return rec(x/2+1,y)+rec(x/2,y)+x*y;
		}
	}
}
int main()
{
	cin >> n >> m;
	a[1][1]=1;
	a[2][1]=4;
	a[1][2]=4;
	a[2][2]=12;
	cout << rec(n,m);
}
